package io.fabric8.kubernetes.api.model;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link CSIPersistentVolumeSource} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractCSIPersistentVolumeSourceAssert<S extends AbstractCSIPersistentVolumeSourceAssert<S, A>, A extends CSIPersistentVolumeSource> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractCSIPersistentVolumeSourceAssert}</code> to make assertions on actual CSIPersistentVolumeSource.
   * @param actual the CSIPersistentVolumeSource we want to make assertions on.
   */
  protected AbstractCSIPersistentVolumeSourceAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual CSIPersistentVolumeSource we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property driver so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert driver()  {
    // check that actual CSIPersistentVolumeSource we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getDriver()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "driver"));
  }


  /**
   * Navigates to the property readOnly so that assertions can be done on it
   */
  public org.assertj.core.api.BooleanAssert readOnly()  {
    // check that actual CSIPersistentVolumeSource we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.BooleanAssert) assertThat(actual.getReadOnly()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "readOnly"));
  }


  /**
   * Navigates to the property volumeHandle so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert volumeHandle()  {
    // check that actual CSIPersistentVolumeSource we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getVolumeHandle()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "volumeHandle"));
  }


}
