package io.fabric8.kubernetes.api.model.rbac;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link KubernetesClusterRole} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractKubernetesClusterRoleAssert<S extends AbstractKubernetesClusterRoleAssert<S, A>, A extends KubernetesClusterRole> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractKubernetesClusterRoleAssert}</code> to make assertions on actual KubernetesClusterRole.
   * @param actual the KubernetesClusterRole we want to make assertions on.
   */
  protected AbstractKubernetesClusterRoleAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual KubernetesClusterRole we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property aggregationRule so that assertions can be done on it
   */
  public KubernetesAggregationRuleAssert aggregationRule()  {
    // check that actual KubernetesClusterRole we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (KubernetesAggregationRuleAssert) assertThat(actual.getAggregationRule()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "aggregationRule"));
  }


  /**
   * Navigates to the property apiVersion so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert apiVersion()  {
    // check that actual KubernetesClusterRole we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getApiVersion()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "apiVersion"));
  }


  /**
   * Navigates to the property kind so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert kind()  {
    // check that actual KubernetesClusterRole we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getKind()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "kind"));
  }


  /**
   * Navigates to the property metadata so that assertions can be done on it
   */
  public io.fabric8.kubernetes.api.model.ObjectMetaAssert metadata()  {
    // check that actual KubernetesClusterRole we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (io.fabric8.kubernetes.api.model.ObjectMetaAssert) assertThat(actual.getMetadata()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "metadata"));
  }


  /**
   * Navigates to the property rules so that assertions can be done on it
   */
  public NavigationListAssert<KubernetesPolicyRule, KubernetesPolicyRuleAssert> rules()  {
    isNotNull();

    // return the assertion for the property
    AssertFactory<KubernetesPolicyRule, KubernetesPolicyRuleAssert> assertFactory = new AssertFactory<KubernetesPolicyRule, KubernetesPolicyRuleAssert>() {
      public KubernetesPolicyRuleAssert createAssert(KubernetesPolicyRule t) {
        return (KubernetesPolicyRuleAssert) assertThat(t);
      }
    };
    NavigationListAssert<KubernetesPolicyRule, KubernetesPolicyRuleAssert> answer = new NavigationListAssert<KubernetesPolicyRule, KubernetesPolicyRuleAssert>(actual.getRules(), assertFactory);
    answer.describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "rules"));
    return answer;
  }


}
