package io.fabric8.kubernetes.api.model.rbac;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link KubernetesClusterRoleBinding} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractKubernetesClusterRoleBindingAssert<S extends AbstractKubernetesClusterRoleBindingAssert<S, A>, A extends KubernetesClusterRoleBinding> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractKubernetesClusterRoleBindingAssert}</code> to make assertions on actual KubernetesClusterRoleBinding.
   * @param actual the KubernetesClusterRoleBinding we want to make assertions on.
   */
  protected AbstractKubernetesClusterRoleBindingAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual KubernetesClusterRoleBinding we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property apiVersion so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert apiVersion()  {
    // check that actual KubernetesClusterRoleBinding we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getApiVersion()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "apiVersion"));
  }


  /**
   * Navigates to the property kind so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert kind()  {
    // check that actual KubernetesClusterRoleBinding we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getKind()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "kind"));
  }


  /**
   * Navigates to the property metadata so that assertions can be done on it
   */
  public io.fabric8.kubernetes.api.model.ObjectMetaAssert metadata()  {
    // check that actual KubernetesClusterRoleBinding we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (io.fabric8.kubernetes.api.model.ObjectMetaAssert) assertThat(actual.getMetadata()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "metadata"));
  }


  /**
   * Navigates to the property roleRef so that assertions can be done on it
   */
  public KubernetesRoleRefAssert roleRef()  {
    // check that actual KubernetesClusterRoleBinding we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (KubernetesRoleRefAssert) assertThat(actual.getRoleRef()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "roleRef"));
  }


  /**
   * Navigates to the property subjects so that assertions can be done on it
   */
  public NavigationListAssert<KubernetesSubject, KubernetesSubjectAssert> subjects()  {
    isNotNull();

    // return the assertion for the property
    AssertFactory<KubernetesSubject, KubernetesSubjectAssert> assertFactory = new AssertFactory<KubernetesSubject, KubernetesSubjectAssert>() {
      public KubernetesSubjectAssert createAssert(KubernetesSubject t) {
        return (KubernetesSubjectAssert) assertThat(t);
      }
    };
    NavigationListAssert<KubernetesSubject, KubernetesSubjectAssert> answer = new NavigationListAssert<KubernetesSubject, KubernetesSubjectAssert>(actual.getSubjects(), assertFactory);
    answer.describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "subjects"));
    return answer;
  }


}
