package io.fabric8.kubernetes.api.model.rbac;

import org.assertj.core.api.AbstractAssert;
import org.assertj.core.api.Assertions;


import io.fabric8.kubernetes.assertions.AssertFactory;
import io.fabric8.kubernetes.assertions.NavigationListAssert;

import static org.assertj.core.api.Assertions.assertThat;
import static io.fabric8.kubernetes.assertions.internal.Assertions.assertThat;
import static io.fabric8.openshift.assertions.Assertions.assertThat;

/**
 * Abstract base class for {@link KubernetesClusterRoleBindingList} specific assertions - Generated by CustomAssertionGenerator.
 */
public abstract class AbstractKubernetesClusterRoleBindingListAssert<S extends AbstractKubernetesClusterRoleBindingListAssert<S, A>, A extends KubernetesClusterRoleBindingList> extends AbstractAssert<S, A> {

  /**
   * Creates a new <code>{@link AbstractKubernetesClusterRoleBindingListAssert}</code> to make assertions on actual KubernetesClusterRoleBindingList.
   * @param actual the KubernetesClusterRoleBindingList we want to make assertions on.
   */
  protected AbstractKubernetesClusterRoleBindingListAssert(A actual, Class<S> selfType) {
    super(actual, selfType);
  }


  /**
   * Navigates to the property additionalProperties so that assertions can be done on it
   */
  public org.assertj.core.api.MapAssert additionalProperties()  {
    // check that actual KubernetesClusterRoleBindingList we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.MapAssert) assertThat(actual.getAdditionalProperties()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "additionalProperties"));
  }


  /**
   * Navigates to the property apiVersion so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert apiVersion()  {
    // check that actual KubernetesClusterRoleBindingList we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getApiVersion()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "apiVersion"));
  }


  /**
   * Navigates to the property items so that assertions can be done on it
   */
  public NavigationListAssert<KubernetesClusterRoleBinding, KubernetesClusterRoleBindingAssert> items()  {
    isNotNull();

    // return the assertion for the property
    AssertFactory<KubernetesClusterRoleBinding, KubernetesClusterRoleBindingAssert> assertFactory = new AssertFactory<KubernetesClusterRoleBinding, KubernetesClusterRoleBindingAssert>() {
      public KubernetesClusterRoleBindingAssert createAssert(KubernetesClusterRoleBinding t) {
        return (KubernetesClusterRoleBindingAssert) assertThat(t);
      }
    };
    NavigationListAssert<KubernetesClusterRoleBinding, KubernetesClusterRoleBindingAssert> answer = new NavigationListAssert<KubernetesClusterRoleBinding, KubernetesClusterRoleBindingAssert>(actual.getItems(), assertFactory);
    answer.describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "items"));
    return answer;
  }


  /**
   * Navigates to the property kind so that assertions can be done on it
   */
  public org.assertj.core.api.StringAssert kind()  {
    // check that actual KubernetesClusterRoleBindingList we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (org.assertj.core.api.StringAssert) assertThat(actual.getKind()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "kind"));
  }


  /**
   * Navigates to the property metadata so that assertions can be done on it
   */
  public io.fabric8.kubernetes.api.model.ListMetaAssert metadata()  {
    // check that actual KubernetesClusterRoleBindingList we want to make assertions on is not null.
    isNotNull();

    // return the assertion for the property
    return (io.fabric8.kubernetes.api.model.ListMetaAssert) assertThat(actual.getMetadata()).describedAs(io.fabric8.kubernetes.assertions.Assertions.joinDescription(this, "metadata"));
  }


}
